const service = require('../services/auth.service');
const { generate_jwt, error_json } = require('../helpers');

const post_login = async (req, res) => {
    try {
        const { email, password } = req.body;
        const salida = await service.post_login({ email, password });
        const { json } = salida;
        const { data: { documento } } = json;
        const access_token = await generate_jwt({ email, documento });
        json['data'].access_token = access_token;

        res.json(json);
    } catch (error) {
        res.status(400).json(error_json(error.message));
    }
};

const post_generar_usuario = async (req, res) => {
    try {
        const { tipo_operacion, correo, perfil } = req.body;
        const salida = await service.post_generar_usuario({ tipo_operacion, correo, perfil });
        const { json } = salida;
        
        res.json(json);
    } catch (error) {
        res.status(400).json(error_json(error.message));
    }
};

const get_account = async (req, res) => {
    try {
        const { documento } = req.params;
        const salida = await service.get_account({ documento });
        const { json } = salida;

        res.json(json);
    } catch (error) {
        res.status(400).json(error_json(error.message));
    }
};

module.exports = {
    post_login,
    post_generar_usuario,
    get_account
};