const { default: axios } = require('axios');
const { encrypt } = require('../helpers/encrypt');
const connection = require('./config');

const post_login = async ({ email, password }) => {
    if (password) {
        const password_encrypt = encrypt(password);

        return await connection.oneOrNone('SELECT * FROM academico.func_tma_login_obtener_v2 ( $1, $2 );', [email, password_encrypt]);
    } else {
        return await connection.oneOrNone('SELECT * FROM academico.func_tma_login_obtener ( $1 );', [email]);
    }
};

const post_generar_usuario = async ({ tipo_operacion, correo, perfil }) => {
    const contrasenia = `Saco+${Math.floor(10000 + (Math.random() * 99999))}`;
    const contrasenia_encriptada = encrypt(contrasenia);

    const response = await connection.oneOrNone('SELECT * FROM seguridad.func_usuario_actualizar ( $1 );', [{ tipo_operacion, correo, contrasenia_encriptada, perfil }]);

    const usuario_login = response.json.data["usuario_login"];

    const response_2 = await connection.oneOrNone('SELECT * FROM seguridad.func_usuario_listar ( $1 );', [{
        tipo_operacion: "plantilla_html_tutor_profesor",
        correo_destinatario: correo,
        usuario_login,
        usuario_contrasenia: contrasenia,
        plataforma_nombre: "TMA"
    }]);

    const remitente = response_2.json.data["correo_remitente"];
    const destinatario = response_2.json.data["correo_destinatario"];
    const asunto = response_2.json.data["correo_asunto"];
    const mensaje = response_2.json.data["correo_mensaje"];
    const url_enviar_correo = `${process.env.URL_SO_API_NOTIFICATION}/notification/sends/many`;
    const response_3 = await axios.post(url_enviar_correo, { fromEmail: remitente, toEmails: ["dtito.ti@sacooliveros.edu.pe"], subject: asunto, mailContent: mensaje });

    return response;
};

const get_account = async ({ documento }) => {
    return await connection.oneOrNone('SELECT * FROM academico.func_tma_cuenta_obtener_v2 ( $1 );', [documento]);
};

module.exports = {
    post_login,
    post_generar_usuario,
    get_account
};